using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using System.IO;

namespace jp.bne.jomora.ImageViewer
{
	/// <summary>
	/// Form1 ̊Tv̐łB
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.PictureBox pictureBox1;
		private System.ComponentModel.IContainer components;

		private string[] filenames;
		private int index = 0;

		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem9;
		private Point mousePoint;

		public static System.Threading.Mutex m1;

		public Form1()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			string[] args = System.Environment.GetCommandLineArgs();
			if (args.Length > 1) 
			{
				string[] filenames = new string[args.Length - 1];
				for (int i = 0; i < args.Length - 1; i++) 
				{
					filenames[i] = args[i + 1];
				}
				this.registFiles(filenames);
				this.viewImage();
			}
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.contextMenu1 = new System.Windows.Forms.ContextMenu();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.SuspendLayout();
			// 
			// pictureBox1
			// 
			this.pictureBox1.BackColor = System.Drawing.Color.Transparent;
			this.pictureBox1.ContextMenu = this.contextMenu1;
			this.pictureBox1.Location = new System.Drawing.Point(0, 0);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(248, 189);
			this.pictureBox1.TabIndex = 0;
			this.pictureBox1.TabStop = false;
			this.pictureBox1.DoubleClick += new System.EventHandler(this.pictureBox1_DoubleClick);
			this.pictureBox1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseMove);
			this.pictureBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pictureBox1_MouseDown);
			// 
			// contextMenu1
			// 
			this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItem4,
																						 this.menuItem9,
																						 this.menuItem1,
																						 this.menuItem2,
																						 this.menuItem7,
																						 this.menuItem3});
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 0;
			this.menuItem4.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem5,
																					  this.menuItem6});
			this.menuItem4.Text = "ړ̂́H";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 0;
			this.menuItem5.Text = "";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Checked = true;
			this.menuItem6.Index = 1;
			this.menuItem6.Text = "摜";
			this.menuItem6.Click += new System.EventHandler(this.menuItem6_Click);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 1;
			this.menuItem9.Text = "-";
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 2;
			this.menuItem1.Text = "Ỏ摜 (,)";
			this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 3;
			this.menuItem2.Text = "̉摜 (,)";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 4;
			this.menuItem7.Text = "ĕ`";
			this.menuItem7.Click += new System.EventHandler(this.menuItem7_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 5;
			this.menuItem3.Text = "";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// Form1
			// 
			this.AllowDrop = true;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 11);
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.ClientSize = new System.Drawing.Size(248, 189);
			this.Controls.Add(this.pictureBox1);
			this.Font = new System.Drawing.Font("MS UI Gothic", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(128)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.SizableToolWindow;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Name = "Form1";
			this.Text = "ImageViewer";
			this.DragDrop += new System.Windows.Forms.DragEventHandler(this.Form1_DragDrop);
			this.DragEnter += new System.Windows.Forms.DragEventHandler(this.Form1_DragEnter);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
			/*
			bool isNew = false;
			m1 = new System.Threading.Mutex(true, "ImageViewer", out isNew);
			if(isNew)
			{
				Application.Run(new Form1());
			}
			else 
			{
				Application.Exit();
			}
			*/
		}

		private void Form1_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
		{
			//Cursor.Current = Cursors.AppStarting;
			//Rg[ɃhbOꂽƂs
			if (e.Data.GetDataPresent(DataFormats.FileDrop)) 
			{
				//hbOꂽf[^`𒲂ׁAt@ĈƂ̓Rs[Ƃ
				e.Effect = DragDropEffects.Copy;
			}
			else 
			{
				//t@CȊO͎󂯕tȂ
				e.Effect = DragDropEffects.None;
			}
		}

		private void Form1_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
		{
			//Rg[ɃhbvꂽƂs
			//hbvꂽׂẴt@C擾
			string[] filenames = (string[])e.Data.GetData(DataFormats.FileDrop, false);
			this.registFiles(filenames);
			this.viewImage();
			this.Activate();
		}

		private void registFiles(string[] filenames) 
		{
			ArrayList fileList = new ArrayList();
			foreach (string filename in filenames) 
			{
				if (File.Exists(filename)) 
				{
					fileList.Add(filename);
				} 
				else if(Directory.Exists(filename)) 
				{
					fileList.AddRange(this.getAllFiles(filename));
				}
			}
			this.filenames = (string[])fileList.ToArray(typeof(string));
			this.index = 0;
		}

		private ArrayList getAllFiles(string dirname)
		{
			ArrayList fileList = new ArrayList();
			foreach (string filename in Directory.GetFiles(dirname))
			{
				if (File.Exists(filename)) 
				{
					fileList.Add(filename);
				} 
			}
			foreach (string subDirname in Directory.GetDirectories(dirname))
			{
				if(Directory.Exists(subDirname)) 
				{
					fileList.AddRange(this.getAllFiles(subDirname));
				}
			}
			return fileList;
		}


		private void pictureBox1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if(this.menuItem5.Checked) 
			{
				if ((e.Button & MouseButtons.Left) != 0)
				{
					this.SetDesktopLocation(
						this.Left + mousePoint.X + e.X,
						this.Top + mousePoint.Y + e.Y);
				}
			} 
			else 
			{
				if ((e.Button & MouseButtons.Left) != 0)
				{
					int newX = this.pictureBox1.Location.X + mousePoint.X + e.X;
					int newY = this.pictureBox1.Location.Y + mousePoint.Y + e.Y;
					if (newX < 0 && newX + this.pictureBox1.Size.Width < this.ClientSize.Width)  
					{
						newX = this.pictureBox1.Location.X;
					} 
					else if (newX > 0 && newX + this.pictureBox1.Size.Width > this.ClientSize.Width)
					{
						newX = this.pictureBox1.Location.X;
					}
					if (newY < 0 && newY + this.pictureBox1.Size.Height < this.ClientSize.Height) 
					{
						newY = this.pictureBox1.Location.Y;
					} 
					else if (newY > 0 && newY + this.pictureBox1.Size.Height > this.ClientSize.Height)	
					{
						newY = this.pictureBox1.Location.Y;
					}
					this.pictureBox1.Location = new Point(newX, newY);
					//this.pictureBox1.Size = this.pictureBox1.Image.Size;
					//this.pictureBox1.Update();
				}
			}
		}

		private void pictureBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if ((e.Button & MouseButtons.Left) != 0)
			{
				//ʒuL
				mousePoint = new Point(-e.X, -e.Y);
			}
		}

		private void viewImage() 
		{
			try 
			{
				this.Text = "[" + (index + 1) + "/" + this.filenames.Length + "] " + Path.GetFileName(this.filenames[this.index]) + " - ImageViewer";

				Stream str = new FileStream(this.filenames[this.index], FileMode.Open, FileAccess.Read);
				byte[] bytes = new byte[str.Length];
				str.Read(bytes, 0, Convert.ToInt32(bytes.Length));
				str.Close();
				MemoryStream ms = new MemoryStream(bytes);
				this.pictureBox1.Image = new Bitmap(ms);
				//ႤƃAjGIFŖ蔭
				//ms.Close();
				this.pictureBox1.Location = new Point(0, 0);
				this.ClientSize = this.pictureBox1.Size = this.pictureBox1.Image.Size;
				insideScreen();
			} 
			catch (Exception ex) 
			{
				this.Text += " : " + ex.Message;
				this.pictureBox1.Image = null;
			}
		}

		private void insideScreen() {
			//this.Update();
			Screen screen = Screen.FromControl(this);
			int dx = 0;
			int dy = 0;
			if (this.Right > screen.WorkingArea.Right) 
			{
				dx = screen.WorkingArea.Right - this.Right;
				//Console.WriteLine("dx : " + dx);
			}
			if (this.Bottom > screen.WorkingArea.Bottom) 
			{
				dy = screen.WorkingArea.Bottom - this.Bottom;
				//Console.WriteLine("dy : " + dy);
			}
			this.Size = new Size(this.Size.Width + dx, this.Size.Height + dy);
		}

		private void pictureBox1_DoubleClick(object sender, System.EventArgs e)
		{
			this.menuItem7_Click(sender, e);
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			if (this.index > 0) 
			{
				this.index--;
				this.viewImage();
			}
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			if (this.filenames != null && this.index < this.filenames.Length - 1) 
			{
				this.index++;
				this.viewImage();
			}
		}

		private void menuItem3_Click(object sender, System.EventArgs e)
		{
			this.Dispose();
			Application.Exit();
		}

		protected override bool ProcessDialogKey(Keys keyData) 
		{ 
			switch(keyData) 
			{ 
				case Keys.Right: 
				case Keys.Up: 
					if (this.index < this.filenames.Length - 1) 
					{
						this.index++;
						this.viewImage();
					}
					return false; 
				case Keys.Left: 
				case Keys.Down: 
					if (this.index > 0) 
					{
						this.index--;
						this.viewImage();
					}
					return false; 
				default: 
					return base.ProcessDialogKey(keyData); 
			} 
		}

		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			this.menuItem5.Checked = true;
			this.menuItem6.Checked = false;
		}

		private void menuItem6_Click(object sender, System.EventArgs e)
		{
			this.menuItem5.Checked = false;
			this.menuItem6.Checked = true;
		}

		private void menuItem7_Click(object sender, System.EventArgs e)
		{
			this.pictureBox1.Location = new Point(0, 0);
			this.ClientSize = this.pictureBox1.Size;
			insideScreen();
		}

	}
}
